//*****************************************************
//
// Quadrado.cpp
// Um programa OpenGL simples que abre uma janela GLUT 
// e faz o desenho de um quadrado cujos vrtices 
// possuem cores diferentes.
//
// Isabel Harb Manssour/Mrcio Serolli Pinho
//
//*****************************************************


#include "glut.h"

// Funo callback de redesenho da janela de visualizao
void Desenha(void)
{
	 // Limpa a janela de visualizao com a cor  
	 // de fundo definida previamente
	 glClear(GL_COLOR_BUFFER_BIT);

	 // Inicializa o sistema de coordenadas
	 glMatrixMode(GL_MODELVIEW);
	 glLoadIdentity();
	
     // Especifica que a cor corrente  vermelha
     //         R     G     B
     glColor3f(1.0f, 0.0f, 0.0f);
  
     // Desenha um quadrado preenchido com a cor corrente
     glBegin(GL_QUADS);
               glVertex2i(100,150);
               glVertex2i(100,100);
               // Especifica que a cor corrente  azul
               glColor3f(0.0f, 0.0f, 1.0f);
               glVertex2i(150,100);
               glVertex2i(150,150);               
     glEnd();

     // Executa os comandos OpenGL
     glutSwapBuffers();
}

// Funo responsvel por inicializar parmetros e variveis
void Inicializa (void)
{   
	// Define a cor de fundo da janela de visualizao como preta
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
}

// Funo callback chamada quando o tamanho da janela  alterado 
void AlteraTamanhoJanela(GLsizei w, GLsizei h)
{
	// Evita a divisao por zero
	if(h == 0) h = 1;

	// Especifica as dimenses da Viewport
	glViewport(0, 0, w, h);

	// Inicializa o sistema de coordenadas
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	// Estabelece a janela de seleo (esquerda, direita, inferior, 
	// superior) mantendo a proporo com a janela de visualizao
	if (w <= h) 
		gluOrtho2D (0.0f, 250.0f, 0.0f*h/w, 250.0f*h/w);
	else 
		gluOrtho2D (0.0f*w/h, 250.0f*w/h, 0.0f, 250.0f);
}

// Programa Principal 
int main(void)
{
	// Define do modo de operao da GLUT
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB); 

	// Especifica a posio inicial da janela GLUT
	glutInitWindowPosition(5,5); 

	// Especifica o tamanho inicial em pixels da janela GLUT
	glutInitWindowSize(450,450);

	// Cria a janela passando como argumento o ttulo da mesma
	glutCreateWindow("Quadrado");

	// Registra a funo callback de redesenho da janela de visualizao
	glutDisplayFunc(Desenha);

	// Registra a funo callback de redimensionamento da janela de visualizao
	glutReshapeFunc(AlteraTamanhoJanela);

	// Chama a funo responsvel por fazer as inicializaes 
	Inicializa();

	// Inicia o processamento e aguarda interaes do usurio
	glutMainLoop();

	return 0;
}


